# 仓库货架网格指引系统



### 项目简介

> 该项目将上位机控制程序和开发板控制程序相结合，上位机提供人机操作界面，将操作信息转换为串口指令，发送到CH32V103开发板，开发板通过控制WS2812灯带上指定区域灯珠的点亮，从而为仓库工作员工提供指引，方便工作人员能够在货架上，快速找到需要操作的格子，极大地提高了工人的工作效率。



### 硬件说明

> 本仓库货架网格指引系统需要使用到的硬件设备非常简洁，主要设备如下：
>
> 1. 主控板使用CH32V103R8T6开发板
> 2. 灯带使用WS2812B炫彩灯带，每米60珠，测试选用1米长，实际使用根据货架实际长度确定
> 3. 电源使用明纬5V 4A开关电源



### 软件说明

> 软件部分分为两部分，一部分为开发板上的控制程序，一部分为上位机上的控制程序。
>
> 1. 开发板上的控制程序：C语言
>
> 2. 1. 监听串口通讯，接收上位机通过串口发送的指令
>    2. 根据接收的指令，向WS2812B灯带发送控制指令，控制指定的灯珠点亮和熄灭
>    3. 将根据实际需要，开发灯带区段显示的效果，如直接点亮、闪亮、射线点亮灯
>
> 3. 上位机上的控制程序：HTML+JS
>
> 4. 1. 提供设置界面，可以设置货架的行数，每行灯珠的数量，每个格子对应的灯珠数量，格子间间隔的灯珠数量等
>    2. 通过设置界面，可以生成映射货架格子的操作界面，点击后，将格子对应区域的灯珠
>    3. 提供串口转HTTP服务的代理程序，方便上位机控制程序调用
>
> 5. 



### 补充说明

> 本项目中，需要驱动WS2812B灯带；对应的功能，在ESP32已经实现，正在做CH32V103@RTT的驱动移植
