/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2020/04/30
* Description        : Main program body.
*******************************************************************************/
#include "ch32v10x.h"
#include <rtthread.h>
#include <rthw.h>
#include "drivers/pin.h"
#include <board.h>
#include <rtdevice.h>
#include <smartboard_uart.h>

#define DBG_TAG "main"
#define DBG_LVL DBG_LOG
#include <rtdbg.h>

/*
 * ָֿܲư
 * ͨƴзֶΣλָӦĵ飬ӶΪԱṩָ
 * ʹõĵƴWS2812B ɫɿ
 * ͨѶʽͨѶ   0|1|2|9 R G B 16ƣд
 *                   0 ȫϨ
 *                   1 ָ
 *                   2 Ϩָ
 *                   9 е
 *                           RGB Ӧɫֵ
 */

/* Global typedef */

/* Global define */

/* LED0ͨrttpinӿ  */
#define LED0_PIN  15   //PA1    ָ״ָ̬ʾ
#define LED0_PIN  11   // WS2812Bָ

/* Global Variable */

void LIGHT_OPEN(int index) {
    rt_kprintf("Open %d\r\n", index);
    // SPIWS2812ֲ
}

void LIGHT_CLOSE(int index) {
    rt_kprintf("Close %d\r\n", index);
    // SPIWS2812ֲ
}

/* LED1ֱͨӵõײ */
void LED1_BLINK_INIT(void)
{
    GPIO_InitTypeDef GPIO_InitStructure;
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_Init(GPIOA, &GPIO_InitStructure);
}


/* mainֻһ֮߳һ֮⻹tshell,idle
   *    mainֻһLED˸main̵߳עrtthread_startup
   *   
 * */
int main(void)
{
    rt_kprintf("\r\n MCU: CH32V103C8T6\r\n");
	rt_kprintf(" SysClk: %dHz\r\n",SystemCoreClock);
    rt_kprintf(" SmartBoard\r\n");
	LED1_BLINK_INIT();

	uart_SMARTBOARD();

	GPIO_ResetBits(GPIOA,GPIO_Pin_0);
	while(1)
	{
	    GPIO_SetBits(GPIOA,GPIO_Pin_0);
	    rt_thread_mdelay(500);

	    GPIO_ResetBits(GPIOA,GPIO_Pin_0);
	    rt_thread_mdelay(500);
	}
    return RT_EOK;
}


/* ʹӿڲI/O */
int led(void)
{
    rt_uint8_t count;

    rt_pin_mode(LED0_PIN, PIN_MODE_OUTPUT);

    for(count = 0 ; count < 10 ;count++)
    {
        rt_pin_write(LED0_PIN, PIN_LOW);
        rt_kprintf("led on, count : %d\r\n", count);
        rt_thread_mdelay(500);

        rt_pin_write(LED0_PIN, PIN_HIGH);
        rt_kprintf("led off\r\n");
        rt_thread_mdelay(500);
    }
    return 0;
}
MSH_CMD_EXPORT(led, RT-Thread first led sample by using I/O driver);



