/*
 * uart2.c
 *
 *  Created on: 20211220
 *      Author: HonestQiao
 */

#include <rtthread.h>
#include <smartboard_uart.h>

#define SMARTBOARD_UART_NAME       "uart2"  /* Ҫ豸 *

/* ڽϢź */
static struct rt_semaphore rx_sem;  /* ź */
static rt_device_t serial;  /* 豸 */

/* ݻص */
static rt_err_t uart_rx_ind(rt_device_t dev, rt_size_t size)
{
    /* ڽյݺжϣô˻صȻͽź */
    if (size > 0)
    {
        rt_sem_release(&rx_sem);
    }
    return RT_EOK;
}

static char uart_SMARTBOARD_get_char(void)
{
    char ch;
    static int rv_flag = 1;

    while (rt_device_read(serial, 0, &ch, 1) == 0)
    {
        rt_sem_control(&rx_sem, RT_IPC_CMD_RESET, RT_NULL);
        if (rv_flag)
            rt_sem_take(&rx_sem, RT_WAITING_FOREVER);
        else if (-RT_ETIMEOUT == rt_sem_take(&rx_sem, 100)) //ʱ100msδô  100Ǹʱӽ ĵλ1/RT_TICK_PER_SECOND 
        {
            rv_flag = 1; //һ֡
            ch = '\n';   //Ҳñĵα֡β
            return ch;
        }
    }
    rv_flag = 0; //ȡһֽ
    return ch;
}

/* ݽ߳ */
static void SMARTBOARD_data_parsing(void)
{
    char rx_temp = 0, rx_len = 0;
    char data_buf[30] = {0};

    while (1)
    {
        rx_temp = uart_SMARTBOARD_get_char();
        if (rx_temp != '\n')
        {
            data_buf[(rx_len++) % 30] = rx_temp; //ֹԽ
        }
        else //ʼһ֡
        {
            rx_len = 0;
            rt_kprintf("uart received data is %s\n", data_buf);
            /* ֡ݴ */
            memset(data_buf, 0, sizeof(data_buf));

            int c1 = data_buf[1];   // ɫRӦֵ
            int c2 = data_buf[2];   // ɫGӦֵ
            int c3 = data_buf[3];   // ɫBӦֵ
            if(data_buf[0] == "0") {
                // ر
                for(int i=0;i<WS2812_LED_MAX;i++) {
                    rt_kprintf("close index=%d\n", i);
                    // WS2812Ϩֲ
                }
            }
            else if(data_buf[0] == "9") {
                // 
                for(int i=0;i<WS2812_LED_MAX;i++) {
                    rt_kprintf("open index=%d\n", i);
                    // WS2812ֲ
                }
            }
            else if(data_buf[0] == "1") {
                // 򿪵
                for(int i=4;i<strlen(data_buf);i++) {
                    rt_kprintf("open index=%d\n", data_buf[i]);
                    // WS2812ֲ
                }
            } else {
                // رյ
                for(int i=4;i<strlen(data_buf);i++) {
                    rt_kprintf("close index=%d\n", data_buf[i]);
                    // WS2812Ϩֲ
                }
            }
        }
    }
}

int uart_SMARTBOARD(void)
{
    rt_err_t ret = RT_EOK;
    /* ϵͳеĴ豸 */
    serial = rt_device_find(SMARTBOARD_UART_NAME);
    if (!serial)
    {
        rt_kprintf("find %s failed!\n", SMARTBOARD_UART_NAME);
        return RT_ERROR;
    }
    /* ʼź */
    rt_sem_init(&rx_sem, "rx_sem", 0, RT_IPC_FLAG_FIFO);
    /* жϽռѯģʽ򿪴豸 */
    rt_device_open(serial, RT_DEVICE_FLAG_INT_RX);
    /* ýջص */
    rt_device_set_rx_indicate(serial, uart_rx_ind);

    /*  serial ߳ */
    rt_thread_t thread = rt_thread_create("SMARTBOARD_thread", (void (*)(void *parameter))SMARTBOARD_data_parsing,
                                          RT_NULL, 512, RT_THREAD_PRIORITY_MAX - 10, 10);
    /* ɹ߳ */
    if (thread != RT_NULL)
    {
        rt_thread_startup(thread);
    }
    else
    {
        ret = RT_ERROR;
    }

    return ret;
}

//INIT_APP_EXPORT(uart_SMARTBOARD);
